function [ energy, output] = Energy( output, km, E_tr, E_pr, amount_flows,txt_fuels,txt_pr_E,amount_pr,cal_val,incineration,bio_energy, bio_tr, process_category)
%UNTITLED Summary of this function goes here
%   Detailed explanation goes here

%--- Transport & Feedstock ---

%make a struct with the energy intensities for each fuel type
E_tr(any(isnan(E_tr),2),:)=[]; %this delete rows
E_pr(any(isnan(E_pr),2),:)=[]; %this delete rows
for i =1:amount_flows
    E_tr_adj(:,i) = E_tr(:,(i-1)*2+1).*E_tr(:,(i-1)*2+2);
end

% make process inflow, mass, feedstock
process = 1;
mass = zeros(size(km,1),amount_flows);
process_inflow = zeros(amount_pr,amount_flows);
feed_energy = zeros(amount_pr, amount_flows);
inflow = zeros(1,amount_flows);
feed = zeros(1,amount_flows);
feedstock = zeros(1,amount_flows);
for i =1:size(output,2)
    if output(i).type =='x' 
        mass(i,:) = sum(output(i).value);
        if output(i).to == process
            inflow = inflow + mass(i,:);
            feed = feed + cal_val'*output(i).value;
            if output(i+1).to ~= process
                feed_energy(process,:) = feed; %feedstock energy in MJ going in each process
                process_inflow(process,:) = inflow; %weight going in each process
                feed = zeros(1,amount_flows);
                inflow = zeros(1,amount_flows);
                process = process + 1; 
            end
        end
        if output(i).from == 0
            feedstock = feedstock + cal_val'*output(i).value; %in MJ
        end
        
    end
end
energy(1).type = 'feedstock';
energy(1).matrix = feedstock;
energy(1).value = sum(sum(energy(1).matrix),2);

amount_fuels = size(txt_fuels,1);
amount_pr_fuels = size(txt_pr_E,1);
transport_energy = zeros(size(km,1),amount_flows);
for i = 1:amount_fuels
    intensity = zeros(size(km,1),amount_flows);
    for j =1:size(km,1)
        intensity(j,:) = E_tr_adj(amount_fuels*(j-1)+i,:);
    end
    transport_fuel(i).type = txt_fuels(i);
    transport_fuel(i).intensity = intensity;
    transport_fuel(i).km = km;
    transport_fuel(i).tonn = mass;
    %Kwh transport energy per flow and fuel type
    transport_fuel(i).energy = transport_fuel(i).intensity.*transport_fuel(i).km.*transport_fuel(i).tonn;
    transport_fuel(i).kwh = sum(transport_fuel(i).energy);
    transport_energy = transport_energy + transport_fuel(i).energy;
end

energy(2).type = 'Transport';
energy(2).matrix = transport_energy;
energy(2).value = sum(sum(energy(2).matrix),2);

for i = 1:size(transport_energy,1)
    output(i).transport = sum(transport_energy(i,:),2);
end

%--- Process ---

%make process fuel stuct. 
process_energy = zeros(amount_pr,amount_flows);
for i =1:amount_pr_fuels
    pr_energy = zeros(amount_pr,amount_flows);
    for j =1:amount_pr
        pr_energy(j,:) = E_pr(amount_pr_fuels*(j-1)+i,:);
    end
    process_fuel(i).type = txt_pr_E(i);
    process_fuel(i).intensity = pr_energy;
    process_fuel(i).inflow = process_inflow;
    process_fuel(i).energy = process_fuel(i).intensity.*process_fuel(i).inflow;
    process_fuel(i).kwh= sum(process_fuel(i).energy);
    process_energy = process_energy + process_fuel(i).energy;
end

energy(3).type = 'process';
energy(3).matrix = process_energy;
energy(3).value = sum(sum(energy(3).matrix),2);

%--- Energy Out---
energy_out = zeros(size(incineration,1) + size(bio_energy,1),2);
brennverdi = zeros(size(incineration,1),2);
%incineration
for i =1:size(incineration,1)
    energy_out(i,1) = incineration(i,1);
    energy_out(i,2)= ((sum(feed_energy(incineration(i,1),:),2))*incineration(i,2))/3.6; %in kwh (in or out incineration (now incl ashes), out?  
    brennverdi(i,1) = incineration(i,1);%process number
    mj = sum(feed_energy(incineration(i,1),:),2);
    tonn = sum(process_inflow(incineration(i,1),:),2)*1000;
    brennverdi(i,2) = mj/tonn; %in MJ/kg
end
%biologicel => give energy markets a name? or all markets?
for i =1:size(bio_energy,1)
    energy_out(i+size(incineration,1),1)= bio_energy(i,1);
    %Vss on both rest and gass => which flows are relevant=
    for j = 1:size(output,2)
        if output(j).type == 'x'
            for t = 1:size(process_category(:,3))
                if and(output(j).from == bio_energy(i,1),output(j).to == process_category(t,3))%fertilizer market found
                    bio_market = process_category(t,3);
                end
            end
        end 
    end
    for z = 1:size(bio_tr,1)
        if bio_energy(i,1) == bio_tr(z,1)
            energy_market = bio_tr(z,4);
        end
    end
    AD = process_inflow(bio_market,:)+process_inflow(energy_market,:);
    energy_out(i+size(incineration,1),2)= sum(AD)*bio_energy(i,2)*bio_energy(i,3)*6.5; %waste in AD * VSS * gass content* 6.5 kwh/Nm3 gass
end

energy(4).type = 'Energy_out';
energy(4).matrix = energy_out;
energy(4).value = sum(energy(4).matrix(:,2));
energy(4).brennverdi = brennverdi;
energy(5).type = 'mass inflow';
energy(5).matrix = process_inflow;
energy(6).type = 'Energy carriers';
energy(6).transport = transport_fuel;
energy(6).process = process_fuel;



end

